
#include <windows.h>
#include "../../../Mausuji/plugin.h"
#include "resource.h"

BOOL Init(void);
void Quit(void);
void Config(PREFS* prefs, CONFIGPARAM* configparam);
void Command(HWND hwnd, LPCWSTR path, COMMANDPARAM* param);

PLUGIN plugin = {
	PLUGIN_VERSION,
	L"sample plugin",
	Init,
	Quit,
	Config,
	Command
};

EXTERN_C PLUGIN * WINAPI GetPlugin(void)
{
	return &plugin;
}

INT_PTR CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static CONFIGPARAM* configparam;
	switch(msg)
	{
	case WM_INITDIALOG:
		configparam = (CONFIGPARAM*)lParam;
		if(!configparam->bInitialized)
		{
			configparam->param.nValue[0] = 1;
			configparam->param.nValue[1] = 2;
			configparam->param.nValue[2] = 3;
			configparam->param.nValue[3] = 4;
			lstrcpy(configparam->param.szText[0], TEXT("sample1"));
			lstrcpy(configparam->param.szText[1], TEXT("sample2"));
			lstrcpy(configparam->param.szText[2], TEXT("sample3"));
			lstrcpy(configparam->param.szText[3], TEXT("sample4"));
		}
		SetDlgItemInt(hwnd, IDC_EDIT1, configparam->param.nValue[0], TRUE);
		SetDlgItemInt(hwnd, IDC_EDIT2, configparam->param.nValue[1], TRUE);
		SetDlgItemInt(hwnd, IDC_EDIT3, configparam->param.nValue[2], TRUE);
		SetDlgItemInt(hwnd, IDC_EDIT4, configparam->param.nValue[3], TRUE);
		SetDlgItemText(hwnd, IDC_EDIT5, configparam->param.szText[0]);
		SetDlgItemText(hwnd, IDC_EDIT6, configparam->param.szText[1]);
		SetDlgItemText(hwnd, IDC_EDIT7, configparam->param.szText[2]);
		SetDlgItemText(hwnd, IDC_EDIT8, configparam->param.szText[3]);
		break;
	case WM_DESTROY:
		configparam->param.nValue[0] = GetDlgItemInt(hwnd, IDC_EDIT1, NULL, TRUE);
		configparam->param.nValue[1] = GetDlgItemInt(hwnd, IDC_EDIT2, NULL, TRUE);
		configparam->param.nValue[2] = GetDlgItemInt(hwnd, IDC_EDIT3, NULL, TRUE);
		configparam->param.nValue[3] = GetDlgItemInt(hwnd, IDC_EDIT4, NULL, TRUE);
		GetDlgItemText(hwnd, IDC_EDIT5, configparam->param.szText[0], MAX_PATH);
		GetDlgItemText(hwnd, IDC_EDIT6, configparam->param.szText[1], MAX_PATH);
		GetDlgItemText(hwnd, IDC_EDIT7, configparam->param.szText[2], MAX_PATH);
		GetDlgItemText(hwnd, IDC_EDIT8, configparam->param.szText[3], MAX_PATH);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL Init(void)
{
	return TRUE;
}

void Quit(void)
{
}

void Config(PREFS* prefs, CONFIGPARAM* configparam)
{
	prefs->hInstance = plugin.hDllInstance;
	prefs->id = IDD_DIALOG;
	prefs->DlgProc = DlgProc;
	prefs->lParam = (LPARAM)configparam;
}

void Command(HWND hwnd, LPCWSTR path, COMMANDPARAM* param)
{
	TCHAR szText[1024];
	wsprintf(szText, TEXT("%d%:%d:%d:%d\n%s\n%s\n%s\n%s"),
		param->nValue[0], param->nValue[1], param->nValue[2], param->nValue[3],
		param->szText[0], param->szText[1], param->szText[2], param->szText[3]);
	MessageBox(hwnd, szText, TEXT("sample plugin"), MB_OK);
}
